<template>
  <div class="app-container">
<!--    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">-->
<!--      <el-form-item label="组合单号" prop="combinationCode">-->
<!--        <el-input-->
<!--          v-model="queryParams.combinationCode"-->
<!--          placeholder="请输入组合单号"-->
<!--          clearable-->
<!--          @keyup.enter.native="handleQuery"-->
<!--        />-->
<!--      </el-form-item>-->
<!--      <el-form-item label="生产工单号" prop="workorderCode">-->
<!--        <el-input-->
<!--          v-model="queryParams.workorderCode"-->
<!--          placeholder="请输入生产工单号"-->
<!--          clearable-->
<!--          @keyup.enter.native="handleQuery"-->
<!--        />-->
<!--      </el-form-item>-->
<!--      <el-form-item label="销售订单号" prop="salesOrderNumber">-->
<!--        <el-input-->
<!--          v-model="queryParams.salesOrderNumber"-->
<!--          placeholder="请输入销售订单号"-->
<!--          clearable-->
<!--          @keyup.enter.native="handleQuery"-->
<!--        />-->
<!--      </el-form-item>-->
<!--      <el-form-item>-->
<!--        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>-->
<!--        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>-->
<!--      </el-form-item>-->
<!--    </el-form>-->

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['pro:combination:add']"
        >新增
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['pro:combination:edit']"
        >修改
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['pro:combination:remove']"
        >删除
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['pro:combination:export']"
        >导出
        </el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="combinationList" @selection-change="handleSelectionChange">

      <el-table-column type="selection" width="55" align="center"/>
      <el-table-column label="组合单号" align="center" prop="combinationCode"/>
      <el-table-column label="序号" align="center" prop="combinationSort"/>
      <el-table-column label="生产工单号" align="center" prop="workorderCode"/>
      <!--      <el-table-column label="销售订单号" align="center" prop="salesOrderId"/>-->
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['pro:combination:edit']"
          >修改
          </el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['pro:combination:remove']"
          >删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改生产组合单对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="组合单号" prop="combinationCode">
          <el-input v-model="form.combinationCode" placeholder="请输入组合单号"/>
        </el-form-item>
        <el-form-item label="序号" prop="combinationSort">
          <el-input v-model="form.combinationSort" placeholder="请输入序号"/>
        </el-form-item>
        <el-form-item label="生产工单号" prop="workorderCode">
          <el-input v-model="form.workorderCode" placeholder="请输入生产工单号"/>
        </el-form-item>
        <el-form-item label="销售订单号" prop="salesOrderNumber">
          <el-input v-model="form.salesOrderNumber" placeholder="请输入销售订单号"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listCombination,
  getCombination,
  delCombination,
  addCombination,
  updateCombination, combList
} from "@/api/mes/pro/combination";
import {genCode} from "@/api/system/autocode/rule";

export default {
  name: "CombinationInfo",
  props: {
    combinationCode: {
      type: String,
      default: null
    }
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 生产组合单表格数据
      combinationList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        combinationCode: null, combinationSort: null, workorderCode: null, salesOrderNumber: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        combinationCode: [
          {required: true, message: "组合单号不能为空", trigger: "blur"}
        ], combinationSort: [
          {required: true, message: "序号不能为空", trigger: "blur"}
        ], workorderCode: [
          {required: true, message: "生产工单号不能为空", trigger: "blur"}
        ], salesOrderNumber: [
          {required: true, message: "销售订单号不能为空", trigger: "blur"}
        ]
      }
    };
  },
  watch: {
    combinationCode: {
      handler(newVal, oldVal) {
        if (newVal) {
          this.queryParams.combinationCode = newVal;
          this.getList();
        }
      },
      immediate: true
    }
  },
  created() {
    this.getList();
  },
  methods: {
    genCode() {
      genCode('COMBINATION_CODE').then(response => {
        this.form.oqcCode = response;
      });
    },
    /** 查询生产组合单列表 */
    getList() {
      this.loading = true;
      listCombination(this.queryParams).then(response => {
        this.combinationList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },


    handleView(row){
      this.reset();
      this.getList();
      const combinationCode = row.combinationCode;
      this.$router.push("/mes/pro/combination/info?combinationCode=" + combinationCode);
    },

    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        combinationId: null, combinationCode: null, combinationSort: null, workorderCode: null, salesOrderNumber: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.combinationId)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加生产组合单";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const combinationId = row.combinationId || this.ids
      getCombination(combinationId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改生产组合单";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.combinationId != null) {
            updateCombination(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addCombination(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const combinationIds = row.combinationId || this.ids;
      this.$modal.confirm('是否确认删除生产组合单编号为"' + combinationIds + '"的数据项？').then(function () {
        return delCombination(combinationIds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {
      });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('pro/combination/export', {
        ...this.queryParams
      }, `combination_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
